---
title: Add multiple recipients to a recipient list. Double opt-in processes will not be overwritten by other opt-in processes (see <a href="https://support.optimizely.com/hc/en-us/articles/4413192291981#prioritization">Opt-in documentation</a>).
slug: campaign/api/add-multiple-recipients-to-a-recipient-list-double-opt-in-processes-will-not-be-overwritten-by-other-opt-in-processes-see-lessa-hrefhttpssupportoptimizelycomhcen-usarticles4413192291981prioritizationgreateropt-in-documenta
docTags: 
createdAt: 2026-09-02T15:04:15.718Z
---

{
  "id": "ijv0oYIBS0U6tBEYdmQuu",
  "type": "api-oas-v2",
  "data": {
    "method": "PUT",
    "url": "https://api.campaign.episerver.net/rest/{clientId}/recipients/{recipientListId}",
    "servers": [
      {
        "url": "https://api.campaign.episerver.net/rest/{clientId}/recipients/{recipientListId}"
      }
    ],
    "name": "Add multiple recipients to a recipient list. Double opt-in processes will not be overwritten by other opt-in processes (see <a href=\"https://support.optimizely.com/hc/en-us/articles/4413192291981#prioritization\">Opt-in documentation</a>).",
    "description": "",
    "contentType": "application/json",
    "request": {
      "pathParameters": [
        {
          "kind": "required",
          "name": "clientId",
          "type": "integer<int64>",
          "description": "Client ID",
          "format": "int64"
        },
        {
          "kind": "required",
          "name": "recipientListId",
          "type": "integer<int64>",
          "description": "Recipient list ID",
          "format": "int64"
        }
      ],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json",
            "application/vnd.optivo.broadmail.v1+json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "optional",
          "name": "body",
          "type": "object",
          "description": "",
          "customType": "CreateRecipientsRequestData",
          "schema": [
            {
              "name": "recipients",
              "kind": "optional",
              "type": "array",
              "description": "",
              "modelRef": "#/components/schemas/ExtendedRecipient",
              "customType": "ExtendedRecipient[]",
              "schema": [
                {
                  "name": "address",
                  "kind": "optional",
                  "type": "string",
                  "description": ""
                },
                {
                  "name": "data",
                  "kind": "optional",
                  "type": "map",
                  "description": "",
                  "example": "",
                  "customType": "map<string, object>",
                  "schema": []
                },
                {
                  "name": "id",
                  "kind": "optional",
                  "type": "string",
                  "description": ""
                }
              ]
            },
            {
              "name": "optinProcessId",
              "kind": "optional",
              "type": "integer<int64>",
              "description": "",
              "format": "int64"
            }
          ],
          "modelRef": "#/components/schemas/CreateRecipientsRequestData",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "Authorization",
          "name": "Authorization",
          "kind": "optional",
          "type": "apiKey",
          "in": "header"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "Adding recipients was initiated successfully.",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "RestRecipientsCreationModify",
            "schema": [
              {
                "name": "count",
                "kind": "optional",
                "type": "integer<int32>",
                "description": "",
                "format": "int32"
              },
              {
                "name": "failedIds",
                "kind": "optional",
                "type": "array",
                "description": "",
                "example": "",
                "itemType": "string",
                "customType": "string[]",
                "itemExample": "",
                "itemDefault": ""
              }
            ],
            "modelRef": "#/components/schemas/RestRecipientsCreationModify",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "409",
        "description": "<p>The indicated opt-in process is not suitable for adding recipients.</p>",
        "jsonExample": "",
        "isExpanded": true
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "DpljacdGwR4kIwhk192kq",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request PUT \\\n     --url https://api.campaign.episerver.net/rest/{clientId}/recipients/{recipientListId} \\\n     --header 'accept: application/json'"
        },
        {
          "id": "hSM-U6nQPHY3hZuDQ68vE",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar requestOptions = {\n   method: 'PUT',\n   headers: myHeaders,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.campaign.episerver.net/rest/{clientId}/recipients/{recipientListId}\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "hfU5meKYtD-aSGjzuGM0s",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.campaign.episerver.net/rest/{clientId}/recipients/{recipientListId}\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Put.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "_suGYKslcTxysFRfMN0Qy",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.campaign.episerver.net/rest/{clientId}/recipients/{recipientListId}\"\n\npayload = {}\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"PUT\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "DpljacdGwR4kIwhk192kq"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// Adding recipients was initiated successfully.\n{\n  \"count\": \"\",\n  \"failedIds\": [\n    \"\"\n  ]\n}"
        },
        {
          "id": "response-1-409",
          "language": "409",
          "code": "// The indicated opt-in process is not suitable for adding recipients.\n"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}